---
title: 'RTCPeerConnection: track event'
slug: Web/API/RTCPeerConnection/track_event
tags:
  - DOM
  - DOM Event Reference
  - Event Reference
  - Media
  - MediaStreamTrack
  - Reference
  - WebRTC
  - WebRTC API
  - events
  - track
---
<div>{{WebRTCSidebar}}</div>

<p><span class="seoSummary">The <strong><code>track</code></strong> event is sent to the {{domxref("RTCPeerConnection.ontrack", "ontrack")}} event handler on {{domxref("RTCPeerConnection")}}s after a new track has been added to an {{domxref("RTCRtpReceiver")}} which is part of the connection.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("RTCTrackEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("RTCPeerConnection.ontrack", "ontrack")}}</td>
  </tr>
 </tbody>
</table>

<p>By the time this event is delivered, the new track has been fully added to the peer connection. See {{SectionOnPage("/en-US/docs/Web/API/RTCTrackEvent", "Track event types")}} for details.</p>

<h2 id="Examples">Examples</h2>

<p>This example shows code that creates a new {{domxref("RTCPeerConnection")}}, then adds a new <code>track</code> event handler.</p>

<pre class="brush: js">pc = new RTCPeerConnection({
  iceServers: [
    {
      urls: "turn:fake.turnserver.url",
      username: "someusername",
      credential: "somepassword"
    }
  ]
});

pc.addEventListener("track", e =&gt; {
  videoElement.srcObject = e.streams[0];
  hangupButton.disabled = false;
}, false);</pre>

<p>The event handler assigns the new track's first stream to an existing {{HTMLElement("video")}} element, identified using the variable <code>videoElement</code>.</p>

<p>You can also assign the event handler function to the {{domxref("RTCPeerConnection.ontrack", "ontrack")}} property, rather than use {{domxref("EventTarget.addEventListener", "addEventListener()")}}.</p>

<pre class="brush: js">pc.ontrack = e =&gt; {
  videoElement.srcObject = e.streams[0];
  hangupButton.disabled = false;
  return false;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#event-track', 'track')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.track_event")}}</p>
